////////////////////////////////////////////////////////////////////////////////////////////////
// Cellular noise ("Worley noise") in 2D in GLSL.
// Copyright (c) Stefan Gustavson 2011-04-19. All rights reserved.
// This code is released under the conditions of the MIT license.
// See LICENSE file for details.
// OpenGL Insights p.101̃TvR[hQ
// HLSLo[WAmemoblog
////////////////////////////////////////////////////////////////////////////////////////////////

// p[^
#define jitter 1.0 // cellular֐pBƌ`
const float scale = 12.5; // cell̑傫Bl傫قǏȂ
const float2 cellOffset = float2(-5, 3); // ꂽƂɂ炷

// wĩNAl
float4 ClearColor = {1,1,1,0};
float ClearDepth  = 1.0;

////////////////////////////////////////////////////////////////////////////////////////////////

// |XgGtFNgł͕Kȉ̐ݒB
float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;


// IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
>;
sampler ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
};

// [xobt@
texture DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
>;


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

// sNZ
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);


struct VS_OUTPUT 
{
    float4 Pos			: POSITION;
    float2 Tex			: TEXCOORD0;
};

struct CELL_OUTPUT 
{
	float2 F;	// distances to features
	float4 d;	// vectors to features
	float index;	// nearest ID
};
////////////////////////////////////////////////////////////////////////////////////////////////
// VF[_
#define Ko 0.428571428571 // 3/7
#define K 0.142857142857 // 1/7
#define K2 0.0714285714285 // K/2
#define EPSILON 0.0000001

float aastep( float threshold, float value )
{
  float afwidth = 0.7 * length( float2(ddx(value), ddy(value)) );
  return smoothstep ( threshold - afwidth, threshold + afwidth, value );
}

// u: (34x^2 + x) mod 289
float3 permute(float3 x) 
{
  return fmod((34.0 * x + 1.0) * x, 289.0);
}

// CellularmCY, F1F2float2ƂĕԂ܂.
// 3x3TĝŁAǂF1F2̒l܂.
CELL_OUTPUT cellular(float2 P) 
{
	// ŋߖTIDTp
	float3 index1; // id
	float3 index2; // id
	float3 index3; // id
	float3 initd1;
	float3 initd2;
	float3 initd3;
	// o͗p\
	CELL_OUTPUT ret;
	float2 Pi = fmod(floor(P), 289.0);
 	float2 Pf = frac(P);
	float3 oi = float3(-1.0, 0.0, 1.0);
	float3 of = float3(-0.5, 0.5, 1.5);
	float3 px = permute(Pi.x + oi);
	// ߖT3sNZIĎvZƈꎞۑ
	float3 p = permute(px.x + Pi.y + oi); // p11, p12, p13
	index1 = p;
	float3 ox = frac(p*K) - Ko;
	float3 oy = fmod(floor(p*K),7.0)*K - Ko;
	float3 d1x = Pf.x + 0.5 + jitter*ox;
	float3 d1y = Pf.y - of + jitter*oy;
	// ߖT3sNZ̋̌vZƈꎞۑ
	float3 d1 = d1x * d1x + d1y * d1y; // d11, d12 and d13, squared
	initd1 = d1;
	// ߖT3sNZIĎvZƈꎞۑ
	p = permute(px.y + Pi.y + oi); // p21, p22, p23
	index2 = p;
	ox = frac(p*K) - Ko;
	oy = fmod(floor(p*K),7.0)*K - Ko;
	float3 d2x = Pf.x - 0.5 + jitter*ox;
	float3 d2y = Pf.y - of + jitter*oy;
	// ߖT3sNZ̋̌vZƈꎞۑ
	float3 d2 = d2x * d2x + d2y * d2y; // d21, d22 and d23, squared
	initd2 = d2;
	// ߖT3sNZIĎvZƈꎞۑ
	p = permute(px.z + Pi.y + oi); // p31, p32, p33
	index3 = p;
	ox = frac(p*K) - Ko;
	oy = fmod(floor(p*K),7.0)*K - Ko;
	float3 d3x = Pf.x - 1.5 + jitter*ox;
	float3 d3y = Pf.y - of + jitter*oy;
	// ߖT3sNZ̋̌vZƈꎞۑ
	float3 d3 = d3x * d3x + d3y * d3y; // d31, d32 and d33, squared
	initd3 = d3;
	
	// ԋ߂sNZւ̋ƁAԖڂɋ߂sNZւ̋vZ邽߂
	// \[gsB
	float3 comp3 = step(d2, d1); 			// d1d2傫1, ȊȌꍇ0Ԃievfj
	float3 d1a = lerp(d1, d2, comp3);  		// d1d2ŏ̒ld1aɓ
	float3 d1xa = lerp(d1x, d2x, comp3);	// d1x, d1y悤ɏl
	float3 d1ya = lerp(d1y, d2y, comp3);
	d2 = lerp(d2, d1, comp3); // F2̂߂ɑ傫̒lĂ
	d2x = lerp(d2x, d1x, comp3);
	d2y = lerp(d2y, d1y, comp3);

	comp3 = step(d3, d2);	// d3d2r
	d2 = lerp(d2, d3, comp3); // d2d3ŏ̒ld2ɂ
	d2x = lerp(d2x, d3x, comp3);
	d2y = lerp(d2y, d3y, comp3);

	comp3 = step(d2, d1a);	// d2d1ar
	d1 = lerp(d1a, d2, comp3); // d1ad2aŏld1ɂ̂ŁAōŏld1ł
	d1x = lerp(d1xa, d2x, comp3);
	d1y = lerp(d1ya, d2y, comp3);
	d2 = lerp(d2, d1a, comp3); // F2̂߂ɑ傫̒lĂ
	d2x = lerp(d2x, d1xa, comp3);
	d2y = lerp(d2y, d1ya, comp3);

	float comp1 = step(d1.y, d1.x);	// d1.yd1.x̔r
	d1.xy = lerp(d1.xy, d1.yx, comp1); // ɕבւ
	d1x.xy = lerp(d1x.xy, d1x.yx, comp1);
	d1y.xy = lerp(d1y.xy, d1y.yx, comp1);

	comp1 = step(d1.z, d1.x);	// d1.xd1.zr
	d1.xz = lerp(d1.xz, d1.zx, comp1); // Γւ̂ŁAF1d1.xɂȂ
	d1x.xz = lerp(d1x.xz, d1x.zx, comp1);
	d1y.xz = lerp(d1y.xz, d1y.zx, comp1);

	float2 comp2 = step(d2.yz, d1.yz);// d2.yzd1.yz̔r
	d1.yz = lerp(d1.yz, d2.yz, comp2); // ̒ld1.yzɂBF2 is now not in d2.yz
	d1x.yz = lerp(d1x.yz, d2x.yz, comp2);
	d1y.yz = lerp(d1y.yz, d2y.yz, comp2);

	comp1 = step(d1.z, d1.y);// d1.zdi.yr
	d1.y = lerp(d1.y, d1.z, comp1); // ̒lBnor in  d1.z
	d1x.y = lerp(d1x.y, d1x.z, comp1);
	d1y.y = lerp(d1y.y, d1y.z, comp1);

	comp1 = step(d2.x, d1.y); // d2.xd1.yr
	d1.y = lerp(d1.y, d2.x, comp1); // ̒̕lB F2d1.yɓ@// F2 is in d1.y, we're done.
	d1x.y = lerp(d1x.y, d2x.x, comp1);
	d1y.y = lerp(d1y.y, d2y.x, comp1);
	
	// ŏIIɂǂIDԋ߂iƗǂ@͂ȂHj
		 if (abs(d1.x - initd1.x) < EPSILON) ret.index = index1.x;
	else if (abs(d1.x - initd1.y) < EPSILON) ret.index = index1.y;
	else if (abs(d1.x - initd1.z) < EPSILON) ret.index = index1.z;
	else if (abs(d1.x - initd2.x) < EPSILON) ret.index = index2.x;
	else if (abs(d1.x - initd2.y) < EPSILON) ret.index = index2.y;
	else if (abs(d1.x - initd2.z) < EPSILON) ret.index = index2.z;
	else if (abs(d1.x - initd3.x) < EPSILON) ret.index = index3.x;
	else if (abs(d1.x - initd3.y) < EPSILON) ret.index = index3.y;
	else if (abs(d1.x - initd3.z) < EPSILON) ret.index = index3.z;
	// ʂ̐ݒ
	ret.F = sqrt(d1.xy);
	ret.d = float4(d1x.x, d1y.x, d1x.y, d1y.y);
	return ret;
}

VS_OUTPUT VS_DrawBuffer( float4 Pos : POSITION, float4 Tex : TEXCOORD0 )
{
    VS_OUTPUT Out; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    
    return Out;
}

// K7FI
float3 stainedColor(float index)
{
  float3 color;
  int c = (int)(index+0.5)%7;
  if (c == 0)
  {
   	color.rgb = float3(1.0, 0, 0);
  }
  else if (c == 1)
  {
    color.rgb = float3(102.0/255.0, 0, 204.0/255.0);
  }
  else if (c == 2)
  {
    color.rgb = float3(1.0, 0.5, 0);
  }
  else if (c == 3)
  {
    color.rgb = float3(0, 0, 1);
  }
  else if (c == 4)
  {
    color.rgb = float3(1, 1, 0);
  }
  else if (c == 5)
  {
    color.rgb = float3(0, 0, 204.0/255.0);
  }
  else if (c == 6)
  {
    color.rgb = float3(0, 153.0/255.0, 0);
  }
  return color;
}

float4 PS_DrawBuffer(float2 Tex: TEXCOORD0) : COLOR
{   
    float4 Color = tex2D( ScnSamp, Tex );
    
    // OpenGL Insights p.101̃TvR[hQ
    CELL_OUTPUT ret = cellular(8.0*Tex);
	float t = 0.05*(length(ret.d.xy-ret.d.zw))/(ret.F.x+ret.F.y);
	float f = ret.F.y - ret.F.x;
	CELL_OUTPUT ret2 = cellular(64.0*Tex);
	f += t*(0.5-ret2.F.y);
	float n = aastep(t, f);
	// IDKɐF
	float3 stained = n*stainedColor(ret.index);
	if (n < 0.5)
	{
		// 
		Color.rgb = stained;
	}
	// ȊO
	else
	{
		Color.rgb = 0.5*(Color.rgb+stained);
	}
    return float4(Color.rgb, 1.0);
}

////////////////////////////////////////////////////////////////////////////////////////////////

technique PostEffect <
    string Script = 
        "RenderColorTarget0=ScnMap;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "ScriptExternal=Color;"
        "RenderColorTarget0=;"
        "RenderDepthStencilTarget=;"
        "Pass=DrawBuffer;"
    ;
> {
    pass DrawBuffer < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_DrawBuffer();
        PixelShader  = compile ps_3_0 PS_DrawBuffer();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
